#!/usr/bin/perl -w
BEGIN { unshift @INC, "./blib/lib" }
use Time::HiRes qw(time);
use POWER::LOG;

# POWER::LOG loading

$t0 = time();
system("perl -e 'use POWER::lib;'");
$t1 = time();
system("perl -e 'BEGIN { unshift \@INC, \"./blib/lib\" } use POWER::LOG;'");
$t2 = time();
printf "%.5f use POWER::LOG;\n", (($t2-$t1)-($t1-$t0));

# POWER::LOG speed

$count = 1000;
$LOG = $POWER::LOG::DEFAULT;
open NULL, ">/dev/null" or die $!;
$LOG->config(OUTPUT=>\*NULL);

sub runtest { $LOG->ERR("test") for 1 .. $count }

$t0 = time();
print NULL "test\n" for 1 .. $count;
$t1 = time();
$t=time(), printf NULL '%d.%05d%s', $t,($t-int($t))*100000," test\n" for 1 .. $count;
$t2 = time();
print NULL time()," test\n" for 1 .. $count;
$t3 = time();
$LOG->config(PREFIX=>'');
$LOG->ERR("test") for 1 .. $count;
$t4 = time();
$LOG->config(PREFIX=>'%S ');
$LOG->ERR("test") for 1 .. $count;
$t5 = time();
$LOG->config(PREFIX=>'%L %S %D %T %P %% ');
$LOG->ERR("test") for 1 .. $count;
$t6 = time();
$LOG->config(PREFIX=>'%L %S %D %T %P %% %F %_ ');
runtest();
$t7 = time();
$LOG->DUMP("test") for 1 .. $count;
$t8 = time();
$LOG->config(PREFIX=>'%L %S %D %T %P %% %F %_ ');
$t9 = time();
$LOG->config(OUTPUT=>undef);
$t10= time();
$LOG->ERR("test") for 1 .. $count;
$t11= time();
$LOG->config(
    OUTPUT  => {
	type=>"unix",
	path=>"",
	},
    PREFIX  => "",
    LEVEL   => "NOTICE",
    );
$LOG->NOTICE("test") for 1 .. $count;
$t12= time();

printf "%.5f $count of print text\n",                   ($t1-$t0);
printf "%.5f $count of print time(optimized)+text\n",   ($t2-$t1);
printf "%.5f $count of print time+text\n",              ($t3-$t2);
printf "%.5f $count of log(no prefix)\n",               ($t4-$t3);
printf "%.5f $count of log with time\n",                ($t5-$t4);
printf "%.5f $count of log with all except caller\n",   ($t6-$t5);
printf "%.5f $count of log with all\n",                 ($t7-$t6);
printf "%.5f $count of log with skipped LEVEL\n",       ($t8-$t7);
printf "%.5f config() with all\n",                      ($t9-$t8);
printf "%.5f $count of log with OUTPUT=undef\n",      ($t11-$t10);
printf "%.5f $count of log with OUTPUT=syslog\n",     ($t12-$t11);

